#ifndef TEMPLATE_H
#define TEMPLATE_H

/*
 * template - implements template functionality
 * for LDAP entries.
 *
 * Author: Helmut Schulz <helmut@thalion-graphics.de>
 *
 * (C) 2006,2007 Hewlett-Packard GmbH Germany
 * (C) 2007 Thalion Graphic Solutions eK
 * All Rights Reserved
 *
 * Developed for Hewlett-Packard GmbH Germany
 * Contact: Bernd Schumacher <bernd.schumacher@hp.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted only as authorized by the
 * GNU Public License 2.0.
 *
 * A copy of this license is available at
 * <http://www.fsf.org/licensing/licenses/gpl.txt>
 */

/*#define TEMPLATE_DEBUG*/
#define TEMPLATE_USECACHE
#define HP_NILVALUE "---"

#define TEMPLATE_AMD64_HACK

#include "slap.h"
#include "template_resolve.h"
#include "template_symtab.h"
#ifdef TEMPLATE_USECACHE
#include "template_cache.h"
#endif

typedef struct template_info {
	struct template_ad_info *hc_ad_info;
	char *base_dn;
	struct berval templatename;
#ifdef HP_NILVALUE
	char *nilvalue;
#endif
	int attribute_cnt;
	template_symtab_t symtab;
#ifdef TEMPLATE_USECACHE
	int cachelines;
	template_cache_t *hc_cache;
#endif
} template_info;

typedef struct template_ad_info {
	struct template_ad_info *hc_next;
	AttributeDescription *hc_ad;
} template_ad_info;

#ifdef HP_NILVALUE
/*
 * If HP/TOM-specific build: undefined attributes may actually be
 * unset, or they have some special value.
 */
#define TEMPLATE_ISNIL(hc,template) \
        (!(template) || !strcmp((template)->bv_val,(hc)->nilvalue))
#else
#define TEMPLATE_ISNIL(hc,template) (!(template))
#endif


#endif

